import _extends from "@babel/runtime/helpers/esm/extends";
// from https://github.com/ReactTraining/react-router/blob/v3/modules/RouterUtils.js#L1

import browserHistory from '../browserHistory.js';
import createMemoryHistory from '../createMemoryHistory.js';
import canUseDOM from './canUseDOM.js';

/**
 * Create the history that the router will use depending on the environment
 */
export var createRouterHistory = function createRouterHistory(options) {
  return canUseDOM ? browserHistory : createMemoryHistory(options);
};

/**
 * Create the router object that will be availble in the context with all the needed info
 * @param {object} history
 * @param {(...args) => boolean } isActive
 * @param {{ location: string, params: object, routes: array }=} state
 * @returns { import('../types').Router }
 */
export var createRouterObject = function createRouterObject(history, isActive, state) {
  if (state === void 0) {
    state = {
      location: null,
      params: null,
      routes: null
    };
  }
  var _state = state,
    location = _state.location,
    params = _state.params,
    routes = _state.routes;
  return _extends({}, history, {
    isActive: isActive,
    location: location,
    params: params,
    routes: routes
  });
};