import _extends from "@babel/runtime/helpers/esm/extends";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
// @ts-check
// from: https://github.com/ReactTraining/react-router/blob/v3/modules/match.js

import { REPLACE } from 'history/lib/Actions';
import { createTransitionManager } from './internal/createTransitionManager.js';
import { fromReactTreeToJSON } from './internal/ReactUtils.js';
import { createRouterHistory, createRouterObject } from './internal/RouterUtils.js';

/**
 * A high-level API to be used for server-side rendering.
 *
 * This function matches a location to a set of routes and calls
 * callback(error, redirectLocation, renderProps) when finished.
 *
 * Note: You probably don't want to use this in a browser unless you're using
 * server-side rendering with async routes.
 * @param {{ history?: object, location, routes: import('react').ComponentType }} options
 * @param {Function} callback Function to be execute after match
 */
export default /*#__PURE__*/(function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref, callback) {
    var externalHistory, location, routes, history, jsonRoutes, transitionManager, _yield$transitionMana, components, redirectLocation, routeInfo, isActive, router, renderProps;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          externalHistory = _ref.history, location = _ref.location, routes = _ref.routes;
          _context.prev = 1;
          history = externalHistory || createRouterHistory(location);
          jsonRoutes = fromReactTreeToJSON(routes);
          transitionManager = createTransitionManager({
            history: history,
            jsonRoutes: jsonRoutes
          });
          _context.next = 7;
          return transitionManager.match(location);
        case 7:
          _yield$transitionMana = _context.sent;
          components = _yield$transitionMana.components;
          redirectLocation = _yield$transitionMana.redirectLocation;
          routeInfo = _yield$transitionMana.routeInfo;
          // if it's not a redirection and we don't have components
          // then we should response with nothing
          if (!redirectLocation && (!components || !components.length)) callback();
          isActive = transitionManager.isActive;
          router = createRouterObject(history, isActive, routeInfo);
          renderProps = _extends({
            components: components,
            router: router,
            matchContext: {
              transitionManager: transitionManager,
              router: router
            }
          }, routeInfo);
          return _context.abrupt("return", callback(null, redirectLocation && history.createLocation(redirectLocation, REPLACE), renderProps));
        case 18:
          _context.prev = 18;
          _context.t0 = _context["catch"](1);
          callback(_context.t0);
        case 21:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 18]]);
  }));
  return function (_x, _x2) {
    return _ref2.apply(this, arguments);
  };
})();